package com.ibm.commerce.telesales.ATPT;
/*
  *-----------------------------------------------------------------
  * Licensed Materials - Property of IBM
  *
  * WebSphere Commerce
  *
  * (C) Copyright IBM Corp. 2009 All Rights Reserved.
  *
  * US Government Users Restricted Rights - Use, duplication or
  * disclosure restricted by GSA ADP Schedule Contract with
  * IBM Corp.
  *-----------------------------------------------------------------
  */
//*---------------------------------------------------------------------
//* The sample contained herein is provided to you "AS IS".
//*
//* It is furnished by IBM as a simple example and has not been  
//* thoroughly tested
//* under all conditions.  IBM, therefore, cannot guarantee its 
//* reliability, serviceability or functionality.  
//*
//* This sample may include the names of individuals, companies, brands 
//* and products in order to illustrate concepts as completely as 
//* possible.  All of these names
//* are fictitious and any similarity to the names and addresses used by 
//* actual persons 
//* or business enterprises is entirely coincidental.
//*---------------------------------------------------------------------


import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import com.ibm.commerce.telesales.ATPT.tracing.ATPTTracingPlugin;
import com.ibm.commerce.telesales.config.ConfigPlugin;
import com.ibm.commerce.telesales.config.IConfigConstants;
import com.ibm.commerce.telesales.core.ITelesalesCommService;
import com.ibm.commerce.telesales.core.TelesalesCommServiceFactory;
import com.ibm.commerce.telesales.exceptions.TelesalesServicesException;
import com.ibm.commerce.telesales.model.Server;
import com.ibm.commerce.telesales.model.ServiceContext;


/**
 * This is the dummay request handler. Which just take the constructed request Bod as string and then
 * call communication layer to process the request.
 */
public class RequestHandler {


    /** IBM copyright notice field */
    private static final String COPYRIGHT = com.ibm.commerce.telesales.copyright.IBMCopyright.SHORT_COPYRIGHT;


	String commServiceId="com.ibm.commerce.telesales.services.TsCommunication";

	public RequestHandler()
	{
	}
	
	/**
	 * This method is construct service context and send the logon request.
	 * @param logonId
	 * @param pwd
	 * @param requestBOD
	 * @param langId
	 * @return
	 * @throws TelesalesServicesException
	 */
	public Object processLogonRequest(String logonId, String pwd,String requestBOD,
			String langId) throws TelesalesServicesException{
		
		if (ATPTTracingPlugin.DEBUG_LOGGING) 
		{
			ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
				IStatus.OK, "processLogonRequest:Entry", null));
		}
		Object response = null;
    	if (requestBOD != null) 
    	{
    		
    		ITelesalesCommService commService = TelesalesCommServiceFactory.getCommService(commServiceId);
    		
    		if(commService==null)
    		{
    				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"
    						), IStatus.ERROR, "Communication instance can not be null", null));
    		}
    		else  
    		{
    					
    					ServiceContext serviceContext = getServiceContext(ServiceContext.SERVICE_TYPE_START,null,"0"
		        				,logonId,pwd,langId,null);
    					if(serviceContext==null)
    					{
    						ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
        							IStatus.ERROR, "ServiceContext can not be null", null));
    					}
    					if (ATPTTracingPlugin.DEBUG_LOGGING) 
    					{
    						ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    							IStatus.OK, "Send Logon request:"+requestBOD, null));
    					}
    					try
						{
    						response = commService.send(serviceContext, requestBOD);
	    					if(response!=null)
	    					{
	    						if (ATPTTracingPlugin.DEBUG_LOGGING) 
	        					{
	        						ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
	        							IStatus.OK, "Response BOD:"+response, null));
	        					}
	    					}
	    					else
	    					{
	    						ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
	        							IStatus.ERROR, "Response is null", null));
	    					}
						}
    					catch(Exception e)
						{
    						ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
        							IStatus.ERROR, "Getting exception while making logon request."+e.toString(), null));
    						TelesalesServicesException tse = new TelesalesServicesException(
    								-1,								// error code
    								-1,								// reason code
    								e.getMessage(), 													// message
    								e.getLocalizedMessage(), 											// localized message
    								(String) null, 														// correlationId
    								new String[] {e.toString()},				// symptom data
    								new Boolean(false) );												// recoverable
    						throw tse;
						}
			}
    		
    	}
    	
    	if (ATPTTracingPlugin.DEBUG_LOGGING) 
		{
		   		ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
				IStatus.OK, "processLogonRequest:Exit", null));
		}

    	return response;
	}
	
	/**
	 * This method is used to process other requests. 
	 * @param userId
	 * @param pwd
	 * @param memberId
	 * @param runAsID
	 * @param storeId
	 * @param requestBOD
	 * @param langId
	 * @return
	 */
	public Object getResponse(String userId,String pwd,String memberId,String runAsID,String storeId,String requestBOD,String langId)
		throws TelesalesServicesException
	{ 
		if (ATPTTracingPlugin.DEBUG_LOGGING) 
		{
			ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
				IStatus.OK, "processOtherRequest:Entry", null));
		}
		Object response = null;
    	if (requestBOD != null) 
    	{
    		ITelesalesCommService commService = TelesalesCommServiceFactory.getCommService(commServiceId);
    		if(commService==null)
    		{
    				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"
    						), IStatus.ERROR, "Communication instance can not be null", null));
    		}
    		else  
    		{
    			ServiceContext serviceContext = getServiceContext(ServiceContext.SERVICE_TYPE_OTHER,runAsID,storeId
	    				,userId,pwd,langId,memberId);
	    		if(serviceContext==null)
				{
					ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
							IStatus.ERROR, "ServiceContext can not be null", null));
				}
    	    		if (ATPTTracingPlugin.DEBUG_LOGGING) 
    	    		{
    	    			ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    	    					IStatus.OK, "Send Other request:"+requestBOD, null));
    	    		}
				try
				{
		    		response = commService.send(serviceContext, requestBOD);
		    		if(response!=null)
					{
		    			if (ATPTTracingPlugin.DEBUG_LOGGING) 
		    			{
		    				ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    							IStatus.OK, "Response BOD:"+response, null));
		    			}
					}
					else
					{
						ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    							IStatus.ERROR, "Response is null", null));
					}
				}
				catch(Exception e)
				{
					ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
							IStatus.ERROR, "Getting exception while processing request."+e.getMessage(), null));
					TelesalesServicesException tse = new TelesalesServicesException(
							-1,								// error code
							-1,								// reason code
							e.getMessage(), 													// message
							e.getLocalizedMessage(), 											// localized message
							(String) null, 														// correlationId
							new String[] {e.toString()},				// symptom data
							new Boolean(false) );												// recoverable
					throw tse;
				}
	
			}
    	}
    	if (ATPTTracingPlugin.DEBUG_LOGGING) 
		{
			ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
				IStatus.OK, "processOtherRequest:Exit", null));
		}
    	return response;
	}
	
	/**
	 * This method is used to construct service context object.
	 * @param serviceType
	 * @param runAsId
	 * @param storeId
	 * @param opeId
	 * @param pwd
	 * @param langId
	 * @param memberID
	 * @return servicecontext object
	 */
	public ServiceContext getServiceContext(String serviceType, String runAsId,String storeId,
			String opeId,String pwd,String langId,String memberID) {
		
	    ServiceContext context = new ServiceContext();
	    context.setServiceType(serviceType);
	    context.setRunAsId(runAsId);
    	context.setMemberId(memberID);
    	
	    if (storeId != null) {
		    context.setStoreId(storeId);
		    
		    if (memberID != null) {
		    	context.setMemberId(memberID);
		    	if (runAsId == null) {
			    	context.setRunAsId(opeId);
		    	}
		    }
	    }
	    else 
	    {
	            storeId = "0"; //$NON-NLS-1$
	    }
	    
	    if(langId==null || langId.trim().length()==0)
		{
			
			langId="-1";
		}
	    context.setLanguageId(langId);
	    context.setChannelId("-4");
	    
	    // Operator
        context.setUserId(opeId);
	    context.setPassword(pwd);
	    
	    // Server configuration
	    Server server = new Server();
	    server.setServerName(ConfigPlugin.getPlugin().getPreferenceStore().getString(IConfigConstants.PREF_SERVER_NAME).trim());
	    server.setPort(ConfigPlugin.getPlugin().getPreferenceStore().getString(IConfigConstants.PREF_PORT_NUMBER).trim());
	    server.setSSLEnabled(ConfigPlugin.getPlugin().getPreferenceStore().getBoolean(IConfigConstants.PREF_SSL_ENABLED));
	    context.setServer(server);

	   return context;
	}
	
	/**
	 * This method is used to process loggoff request.
	 * @param logonId
	 * @param pwd
	 * @param requestBOD
	 * @param memberId
	 * @param langId
	 * @return
	 */
	public void  processLogoffRequest(String logonId, String pwd,String memberId,String langId) throws TelesalesServicesException
	{
    		ITelesalesCommService commService = TelesalesCommServiceFactory.getCommService(commServiceId);
    
    		if(commService==null)
    		{
    				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"
    						), IStatus.ERROR, "Communication instance can not be null", null));
    		}
    		else  
    		{
    	    			ServiceContext serviceContext = getServiceContext(ServiceContext.SERVICE_TYPE_STOP,memberId,"0"
		        				,logonId,pwd,langId,memberId);
    	        		if(serviceContext==null)
    					{
    						ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    								IStatus.ERROR, "ServiceContext can not be null", null));
    					}
    		
    					try
						{
    						if(ATPTTracingPlugin.DEBUG_LOGGING)
    						{
    							ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    								IStatus.OK, "Send logoff request:", null));
    						}
    						commService.send(serviceContext, null);
						}
    					catch(Exception e)
						{
    						ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"),
    								IStatus.ERROR, "Getting exception while processing logoff request."+e.getMessage(), null));
    						TelesalesServicesException tse = new TelesalesServicesException(
    								-1,								// error code
    								-1,								// reason code
    								e.getMessage(), 													// message
    								e.getLocalizedMessage(), 											// localized message
    								(String) null, 														// correlationId
    								new String[] {e.toString()},				// symptom data
    								new Boolean(false) );												// recoverable
    						throw tse;
    					}
    		}
	}
	
}
